#!/usr/bin/perl

use Freeride;

$totaldest = 0;#7;
$totalsearch = 10;
$totalfeat = 10;
$totalrlgl = 5;
$totalhh = 20;#50;
$totalbus = 30;#100;

#command line stuff
$| = 1;

%users = Freeride::getusers();

#open STDOUT, ">> /home/apenner/freeride/freeride.log";

$numargs = $#ARGV+1;
if ($numargs < 1)
{
  usage:
    print STDOUT "Usage: $0 [options] username\n";
    print STDOUT "Options:\n   s: Don't do search pages\n   d: Don't do destination points\n   f: Don't do featured sponsors\n   c=[10|15|20|25]: Cash out for that value amazon.com GC (or higher)\n   o: Sign up for special offer mailing lists.\n   b: Don't ride the magic bus.\n";
    exit(1);	
}

$num = 0;
$dodest = 1;
$dosearch = 1;
$dofeat = 1;
$cashout = 0;
$dospecial = 0;
$dobus = 1;

if ($numargs == 2)
{
    $num = 1;
    if ($ARGV[0] =~ /s/) { $dosearch = 0; }
    if ($ARGV[0] =~ /f/) { $dofeat = 0; }
    if ($ARGV[0] =~ /d/) { $dodest = 0; }
    if ($ARGV[0] =~ /c/)
    {
	$cashout = $ARGV[0];
	$cashout =~ s/.*?c\=(\d*).*/$1/s;
	if ($cashout != 10 && $cashout != 15 && $cashout != 20 &&
	    $cashout != 25)
	{
	    goto usage;
	}
    }
    if ($ARGV[0] =~ /o/) { $dospecial = 1; }
    if ($ARGV[0] =~ /b/) { $dobus = 0; }
}

$username = $ARGV[$num];
$pass = $users{$username};

# login
print STDOUT "Logging in $username... ";
$userno = Freeride::login($username, $pass);
if ($userno == -1) { print STDOUT "failed.\n"; exit(1); }
else { print STDOUT "success.\n"; }

#check wallet
print STDOUT "Checking wallet...\n";
($destdone, $searchdone, $featdone, $rlgldone, $hhdone, $busdone, $totaltoday)=Freeride::check_wallet($userno);
print STDOUT "$destdone destination points visited, ",$totaldest-$destdone," left.\n";
print STDOUT "$searchdone searches done, ",$totalsearch-$searchdone," left.\n";
print STDOUT "$featdone featured sponsers visited, ",$totalfeat-$featdone," left.\n";
print STDOUT "$rlgldone red light/green light surveys taken, ",$totalrlgl-$rlgldone," left.\n";
print STDOUT "$hhdone hitchhikers picked up, ",$totalhh-$hhdone," left.\n";
$busdone *= 10;
print STDOUT "$busdone minutes ridden on magic bus, ", $totalbus-$busdone," left.\n";

#getpoints
$oldtotpoints = Freeride::getpoints($userno);
print STDOUT "You started this session with $oldtotpoints points.\n";

if ($dodest == 1) { getdestpoints(); }
if ($dosearch == 1) { dosearch(); }
if ($dofeat == 1) { featuredsponsers(); }
if ($dospecial == 1) { dospecial(); }
if ($dobus == 1) { dobus(); }

$newtotpoints = Freeride::getpoints($userno);
($destdone, $searchdone, $featdone, $rlgldone, $hhdone, $busdone, $totaltoday)=Freeride::check_wallet($userno);
print STDERR "$username: This session got ", $newtotpoints-$oldtotpoints, " points, you got $totaltoday today, and you have $newtotpoints\n";
print STDOUT "$username: This session got ", $newtotpoints-$oldtotpoints, " points, you got $totaltoday today, and you have $newtotpoints\n\n\n";


if ($cashout != 0) { docashout(); }

sub getdestpoints
{
    my $i;
    my $thisdest;
    my $newpoints;
    $count = 0;
    for ($i = 0; $i < $totaldest-$destdone; $i++)
    {
	print STDOUT "Destination point ",$destdone+$i+1,": ";
      retry:
	sleep(1);
	$count++;
	($thisdest, $newpoints) = Freeride::do_dest($userno, 6);
	if ($thisdest == -1 && $count < 60) { print STDOUT "."; goto retry; }
	elsif ($thisdest != -1) { print STDOUT "$thisdest: $newpoints\n"; }
	elsif ($count >= 60)
	{ print STDOUT "Maximum tries reached.  Giving up.\n"; goto destdone; }
    }
  destdone:
}

sub randomword
{
    my $num = (rand()*10000000) % 45404;
    my $i, $j;
    open WORDS, "words";
    for ($i = 0; $i < $num; $i++)
    {
	$j = <WORDS>;
    }
    close WORDS;
    return $j;
}

sub featuredsponsers
{
    my $i;
    my $thisfeat;
    my $newpoints;
    $count = 0;
    for ($i = 0; $i < $totalfeat-$featdone; $i++)
    {
	print STDOUT "Featured sponser ",$featdone+$i+1,": ";
      retry:
	sleep(1);
	$count++;
	($thisfeat, $newpoints)=Freeride::do_sponser($userno, $count % 11);
	if ($thisfeat == -1 && $count < 28) { print STDOUT "."; goto retry; }
	elsif ($thisfeat != -1) { print STDOUT "$thisfeat: $newpoints\n"; }
	elsif ($count >= 28)
	{ print STDOUT "Maximum tries reached.  Giving up.\n"; goto featureddone; }
    }
  featureddone:
}

#sub dorlgl
#{
#    my $i;
#    my $thisrlgl;
#    my $newpoints;

#    $count = 0;
#    for ($i = 0; $i < $totalrlgl - $rlgldone; $i++)
#    {
#	print STDOUT "Red light/Green light ", $rlgldone +$i + 1, ": ";
#      retry:
#	$count++;
#	($thisrlgl, $newpoints) = Freeride::do_rlgl($userno);
#	if ($thisrlgl == -1 && $count < 500)
#	{
#	    # don't print STDOUT so many dots
#	    if ($count % 5 == 0) { print STDOUT "."; }
#	    sleep 1;
#	    goto retry;
#	}
#	elsif ($thisrlgl != -1) { print STDOUT "$thisrlgl: $newpoints\n"; }
#	elsif ($count >= 500)
#	{ print STDOUT "Maximum tries reached.  Giving up.\n"; goto rlgldone; }
#    }
#  rlgldone:
#}

sub dosearch
{
    my $i;
    my $thissearch;
    my $newpoints;
    my $keyword;
    $count = 0;
    for ($i = 0; $i < $totalsearch-$searchdone; $i++)
    {
	print STDOUT "Search ",$searchdone+$i+1,": ";
      retry:
	sleep(1);
	$keyword = randomword();
	$count++;
	($thissearch, $newpoints) = Freeride::randomsearch($userno, $keyword);
	if ($thissearch == -1 && $count < 15) { print STDOUT "."; goto retry; }
	elsif ($thissearch != -1) { print STDOUT "$thissearch: $newpoints\n"; }
	elsif ($count >= 15)
	{ print STDOUT "Maximum tries reached.  Giving up.\n"; goto searchdone; }
    }
  searchdone:
}

sub dobus
{
    if ($busdone < $totalbus)# || $hhdone < $totalhh)
 { print STDOUT "Riding the magic bus...\n"; } 
    while ($busdone < $totalbus)# || $hhdone < $totalhh)
 {
     ($b, $h) = Freeride::ridethebus($userno);
     $busdone = $b;
     $hhdone += $h;
     if ($busdone >= $totalbus)# && $hhdone >= $totalhh)
     { print "\nPicked up $hhdone hitchhikers today.\n"; }
 }	
}

sub dospecial
{
    print STDOUT "Special offers: ";
    ($pts, $tot) = Freeride::special($userno);
    print STDOUT "$pts: $tot\n";
}

sub docashout
{
    print STDOUT "Cashing out...";
    my $oldpoints = Freeride::getpoints($userno);
    my $tot = 0;
    my $newpoints;
    
    while(Freeride::getpoints($userno) > 2499)
    {
	$i++;
	if (Freeride::cashout($userno, 25) == 25)
	{
	    print STDOUT "\$25 ";
	    $tot += 25;
	}
    }
    if ($cashout == 25) { goto cashdone; }
    
    while(Freeride::getpoints($userno) > 1999)
    {
	$i++;
	if (Freeride::cashout($userno, 20) == 20)
	{
	    print STDOUT "\$20 ";
	    $tot += 20;
	}
    }
    if ($cashout == 20) { goto cashdone; }
    
    while(Freeride::getpoints($userno) > 1499)
    {
	$i++;
	if (Freeride::cashout($userno, 15) == 15)
	{
	    print STDOUT "\$15 ";
	    $tot += 15;
	}
    }
    if ($cashout == 15) { goto cashdone; }
    
    while(Freeride::getpoints($userno) > 999)
    {
	$i++;
	if (Freeride::cashout($userno, 10) == 10)
	{
	    print STDOUT "\$10 ";
	    $tot += 10;
	}
    }
    if ($cashout == 10) { goto cashdone; }
    
#    while(Freeride::getpoints($userno) > 499)
#    {
#	$i++;
#	if (Freeride::cashout($userno, 5) > 0) { $cashouts[$i] = 5; }
#	else { $cashouts[$i] = 0; }
#    }
  cashdone:
 
    print STDOUT "\nTotal: \$$tot, ";
    $newpoints = Freeride::getpoints($userno);
    print STDOUT $oldpoints - $newpoints;
    print STDOUT " points spent.  You have $newpoints points left.\n";

    print STDERR "\nTotal: \$$tot, ";
    print STDERR $oldpoints - $newpoints;
    print STDERR " points spent.  You have $newpoints points left.\n";
}
		
